
local timer = 0
local nextTimeout = 0

local started = true
local exploded = false
local firekilled = false
local damagedone = false

function Create()
	this.Countdown = 1.0
	this.Blown = false
	started = false
end

function Update(timePassed)
    timer = timer + timePassed;
    if timer > nextTimeout then
        nextTimeout = IntervalUpdate(timer)
        timer = 0
    end   
end   

function IntervalUpdate(timePassed)
	if started == false then
		this.Sound("__RiotAssault", "Explosion")
		StartFire(this.Pos.x, this.Pos.y)
		started = true
	elseif exploded == false then
		Explode()
		exploded = true
	elseif firekilled == false then
		KillFires()
		firekilled = true
	elseif damagedone == false then
		DoSurroundingDamage()
		damagedone = true

		this.Delete()
	end
	return 0.25
end

function Explode()
	local force = 0.25
	
	local entityTypes = { "Prisoner", "Workman", "Guard", "Dog", "ParoleOfficer", "ParoleLawyer", "AppealsLawyer", "DogHandler", "ArmedGuard", "RiotGuard", "Teacher", "SpiritualLeader", 
				"AppealsMagistrate", "BasketballTrainer", "Visitor", "Doctor", "Cook", "Gardener", "Janitor", "Psychologist", "Paramedic", "Fireman", "Soldier", "ExecutionWitness",
				"Sniper", "TruckDriver", "Warden", "Chief", "Foreman", "Accountant", "Lawyer", "YogaMaster", "BarberChief", "Barber", "TowTruckDriver", "LimoDriver", "CarMechanic", 
				"SomeFriendParlour1", "SomeFriendParlour2", "SomeFriendParlour3", "SomeFriendParlour4", "SomeFriendParlour5", "SomeFriendCemetery", "SomeFriendFuneral", "SomeFriendLeaving", "CarMechanicHelper", "SpiritualLeaderParlour", "TeslaMaticExpert", "ShadyTeslaDude", "ChinookPilot",
				"ChinookGuard", "GraveDigger", "PlantationWorker", "GardenWorker",  "ForestryWorker",
				"PrisonFiremanA0", "PrisonFiremanA1", "PrisonFiremanA2", "PrisonFiremanA3", "PrisonFiremanB0", "PrisonFiremanB1", "PrisonFiremanB2", "PrisonFiremanB3", "Tailor",
				"PrisonFiremanC0", "PrisonFiremanC1", "PrisonFiremanC2", "PrisonFiremanC3", "PrisonFiremanD0", "PrisonFiremanD1", "PrisonFiremanD2", "PrisonFiremanD3" }
				
	for i,entityType in ipairs( entityTypes ) do 
        FindEntitiesToDamage(entityType, 2, force)
    end
end

function DoSurroundingDamage()
	local objectTypes = { "Chair", "Bed", "BunkBed", "PrayerMat", "Bookshelf", "ShowerHead", "PrisonerUniform", "DirtyPrisonerUniform",
				"Drain", "OfficeDesk", "Tv", "Radio", "Toilet", "NiceToilet", "NiceToilet2", "TurkishDrain", "Urinal", "WallSink"}
		
	for i,objectType in ipairs( objectTypes ) do 
        FindStuffToDamage(objectType, 1)
    end
end

function FindStuffToDamage(typeName, distance)
    local objects = Object.GetNearbyObjects(typeName, distance)
    for obj, dist in pairs(objects) do
		if obj.Type == "ShowerHead" or obj.Type == "WallSink" or obj.Type == "Toilet" or obj.Type == "NiceToilet" or obj.Type == "NiceToilet2" or obj.Type == "TurkishDrain" or obj.Type == "Drain" or obj.Type == "Urinal" then
			local rubble = Object.Spawn( "Rubble", obj.Pos.x, obj.Pos.y )
			local velX = -0.5+math.random()+math.random()
			local velY = -0.5+math.random()+math.random()
			Object.ApplyVelocity(rubble, velX, velY)
		end
		if dist <= 0.5 and obj.Type == "PrisonerUniform" or obj.Type == "DirtyPrisonerUniform" then
			local fire = Object.Spawn( "Fire", obj.Pos.x, obj.Pos.y )
			fire.Fuel = math.random()
			fire.Intensity = math.random()
		end
		obj.Damage = 0.85
   end
	
end

function FindEntitiesToDamage(typeName, distance, damage)
    local objects = Object.GetNearbyObjects(typeName, distance)
    for obj, dist in pairs(objects) do
        local curr = tonumber(obj.Damage) or 0

		local velX = obj.Pos.x - this.Pos.x
		if velX ~= 0 then
			velX = (dist/velX)*1.5
		end
		local velY = obj.Pos.y - this.Pos.y
		if velY ~= 0 then
			velY = (dist/velY)*1.5
		end
		Object.ApplyVelocity(obj, velX, velY)
		
        if curr < 1 then
			if dist < 1 then
				dist = 1
			end
			curr = math.min(curr + (damage / dist), 1)
			if curr < 1 then
				obj.Damage = curr
			else
				if SetStatus(Patient, "wounded", 1) then
				else
					obj.Damage = curr
				end
			end
        end
    end
end

function StartFire(targetX,targetY)
	local count = 0
	while count < 5 do
		local fire = Object.Spawn("Fire", targetX, targetY)
		fire.Fuel = 0.5
		fire.Intensity = 1.0
		fire.Spawned = this.Id.u
		count = count + 1
	end
end
		
function KillFires()
	local objects = Object.GetNearbyObjects("Fire", 5)
	for obj, dist in pairs(objects) do
		if not obj.Spawned or obj.Spawned == this.Id.u then
			obj.Delete()
		end
	end
end

function SetStatus(obj, key, value)
	if pcall(TryTableEntry, obj, "StatusEffects", key, value) then
		return true
	else                    
		return false
	end	
end
