
local timeRing=0
local Frame=1
local timeBatteryAnim=0
local timeTot=0
local timeInit = 0
local initTimer = math.random(1,5) / 0.75
local Now = 0
local StartingMinute = 0
local myTimeWarpFactor = 1
local myBatteryEnergy = 999
local Find = this.GetNearbyObjects

function Create()
	Set("Tooltip","tooltip_Init_TimeWarp")
	local velX = -1.0 + math.random() + math.random()
	local velY = -1.0 + math.random() + math.random()
	Object.ApplyVelocity(this, velX, velY)
	Set("BatteryChecked",false)
	Set("BatteryLoad",999)
	CheckBatteryHealth()
	Set("V2",true)
	local nearbyDetectors = Find("SmartPhoneDetector",25)
	if next(nearbyDetectors) then
		for thatDetector, dist in pairs(nearbyDetectors) do
			if thatDetector.TimeWarp ~= nil then
				Set("TimeWarp",thatDetector.TimeWarp)
				break
			end
		end
	end
end

function ClearSmoke()
	local nearbySmoke = Object.GetNearbyObjects(this,"SmokeGenerator",3)
	if next(nearbySmoke) then
		for thatSmoke,distance in pairs(nearbySmoke) do
			thatSmoke.Delete()
		end
	end
	nearbySmoke=nil
end

function Update(timePassed)
	if this.TimeWarp == nil then
		if World.TimeWarpFactor ~= nil then
			Set("TimeWarp",World.TimeWarpFactor)
			Set("Tooltip","")
		else
			CalculateTimeWarpFactor(timePassed)
		end
		return
	elseif timePerUpdate==nil then
		if not Get("V2") then this.Delete() return end
		myTimeWarpFactor = Get("TimeWarp")
		myBatteryEnergy = Get("BatteryLoad")
		timePerRingtone=math.random(30,60) / myTimeWarpFactor
		timePerUpdate = 1 / myTimeWarpFactor
		if Get("DeadBattery") == true then
			timePerAnim=math.random(1,3) / myTimeWarpFactor
			Animation = { [1] = 0, [2] = 5 }
			Object.Sound("SmartPhone","Ringtone6")
			local mX=Object.GetProperty(this,"Pos.x")
			local mY=Object.GetProperty(this,"Pos.y")
			smoke = Object.Spawn( 'SmokeGenerator', mX, mY )
--			if Get("Letter")~=nil then
	--			this.Tooltip={ "tooltip_deadbatteryWithLetter","tooltip_lettercontents"..this.Letter,"X",this.BatteryLoad,"Y" }
--			else
				this.Tooltip={ "tooltip_deadbattery",this.BatteryLoad,"Y" }
--				Set("Tooltip","tooltip_init_deadbattery")
--			end
	--	else
	--		timePerAnim = 7400 / myTimeWarpFactor	-- never animate a healthy smartphone
	--		local newRingtone=math.random(1,5)
	--		Object.Sound("SmartPhone","Ringtone"..newRingtone)
--			if Get("Letter")~=nil then
	--			this.Tooltip={ "tooltip_SmartfoneWithLetter","tooltip_lettercontents"..this.Letter,"X",this.BatteryLoad,"Y" }
--			else
--				this.Tooltip={ "tooltip_smartfone",this.BatteryLoad,"Y" }
	--		end
		end
		Interface.AddComponent(this,"toggleSeizeSmartPhone", "Button", "tooltip_button_SeizePhone")
	end

	timeTot=timeTot+timePassed
	timeRing=timeRing+timePassed
	timeBatteryAnim=timeBatteryAnim+timePassed

	if timeTot>=timePerUpdate then
		timeTot=0
		
		if Get("DeadBattery") == true then
			if Get("Letter")==nil then
				this.Tooltip={ "tooltip_deadbattery",this.BatteryLoad,"Y" }
			else
				this.Tooltip={ "tooltip_deadbatteryWithLetter","tooltip_lettercontents"..this.Letter,"X",this.BatteryLoad,"Y" }
			end
--		else
--			if Get("Letter")==nil then
--				this.Tooltip={ "tooltip_smartfone",this.BatteryLoad,"Y" }
--			else
--				this.Tooltip={ "tooltip_SmartfoneWithLetter","tooltip_lettercontents"..this.Letter,"X",this.BatteryLoad,"Y" }
--			end
		end
		
		myBatteryEnergy = myBatteryEnergy -1
		Set("BatteryLoad",myBatteryEnergy)
		if Get("BatteryLoad") <= 0 then
			if Get("DeadBattery") == true then
				ExplodedSeizedSmartPhone()
			else
				this.Delete()
			end
		end
		
		if timeBatteryAnim>=timePerAnim then
			timeBatteryAnim=0
			timePerAnim=math.random(1,3) / myTimeWarpFactor
			Frame = Frame + 1
			if Frame > 2 then
				Frame = 1
			end
			Set("SubType",Animation[Frame]) -- animate the battery indicator
		end

		if timeRing>=timePerRingtone then
			timeRing=0
			timePerRingtone=math.random(30,60) / myTimeWarpFactor
			if Get("DeadBattery") == false then
				local newRingtone=math.random(1,5)
				Object.Sound("SmartPhone","Ringtone"..newRingtone)
			else
				Object.Sound("SmartPhone","Ringtone6")
			end
		end
	end
end

function CheckBatteryHealth()
	if this.BatteryChecked==false then
--		BatteryHealth=math.random(1,50)
--		FaultyProduct=math.random(1,50)
--		if BatteryHealth==FaultyProduct then
			Set("DeadBattery",true)
			Set("BatteryLoad",math.random(30,60))
			myBatteryEnergy = Get("BatteryLoad")+math.random()
			if Get("Letter")==nil then
				this.Tooltip={ "tooltip_deadbattery",this.BatteryLoad,"Y" }
			else
				this.Tooltip={ "tooltip_deadbatteryWithLetter","tooltip_lettercontents"..this.Letter,"X",this.BatteryLoad,"Y" }
			end
--		else
--			Set("DeadBattery",false)
--			Set("BatteryLoad",360)
--			Set("SubType",math.random(1,4))
--			if Get("Letter")==nil then
--				this.Tooltip={ "tooltip_smartfone",this.BatteryLoad,"Y" }
--			else
--				this.Tooltip={ "tooltip_SmartfoneWithLetter","tooltip_lettercontents"..this.Letter,"X",this.BatteryLoad,"Y" }
--			end
--		end
		Set("BatteryChecked",true)
	end
end

function toggleSeizeSmartPhoneClicked()
	SeizedPhone=Object.Spawn("SeizedSmartPhone", this.Pos.x,this.Pos.y)
	SetOn(SeizedPhone,"SubType",this.SubType)
	if Get("Letter")~=nil then
		SetOn(SeizedPhone,"Letter",this.Letter)
	end
	SetOn(SeizedPhone,"Tooltip","tooltip_SeizedSmartPhone")
	local velX = -1.0 + math.random() + math.random()
	local velY = -1.0 + math.random() + math.random()
	Object.ApplyVelocity(SeizedPhone, velX, velY)
	if this.DeadBattery~=nil then ClearSmoke() end
	this.Delete()
end

function ExplodedSeizedSmartPhone()
	Object.Spawn("BatteryExplosion", this.Pos.x,this.Pos.y)
	SeizedPhone = Object.Spawn("ExplodedSmartPhone", this.Pos.x,this.Pos.y)
	if Get("Letter")~=nil then
		SetOn(SeizedPhone,"Letter",this.Letter)
	end
	phoneBurst = Object.Spawn("BatteryEnergyBurst", SeizedPhone.Pos.x,SeizedPhone.Pos.y)
	local velX = -1.0 + math.random() + math.random()
	local velY = -1.0 + math.random() + math.random()
	Object.ApplyVelocity(SeizedPhone, velX, velY)
	Object.ApplyVelocity(phoneBurst, velX, velY)
	ClearSmoke()
	SeizedPhone.Damage = 1
	this.Delete()
end

function CalculateTimeWarpFactor(timePassed)
	if timeInit > initTimer then
	
		if timePerUpdate == nil then
			Now = math.floor(math.mod(World.TimeIndex,60))
			if not StartCountdown then
				if Now > StartingMinute then
				--	this.SubType = 1
					StartingMinute = Now
					StartCountdown = true
					this.Tooltip = {"tooltip_Init_TimeWarpB",StartingMinute,"A",StartingMinute+5,"B",Now,"C",0,"D" }
				end
			else
				timeTot=timeTot+timePassed
				this.Tooltip = {"tooltip_Init_TimeWarpB",StartingMinute,"A",StartingMinute+5,"B",Now,"C",timeTot,"D" }
				if Now >= StartingMinute+5 then
				--	print("now>start")
					if timeTot > 9 then		-- the result should be around 9.99 for large map
						myTimeWarpFactor = 0.5
				--		this.SubType = 2
						this.Tooltip = {"tooltip_Init_TimeWarpC",StartingMinute,"A",StartingMinute+5,"B",Now,"C",timeTot,"D","Large","E",myTimeWarpFactor,"F" }
					elseif timeTot > 6 then	-- the result should be around 6.66 for medium map
						myTimeWarpFactor = 0.75
				--		this.SubType = 3
						this.Tooltip = {"tooltip_Init_TimeWarpC",StartingMinute,"A",StartingMinute+5,"B",Now,"C",timeTot,"D","Medium","E",myTimeWarpFactor,"F" }
					else					-- the result should be around 5 for small map
						myTimeWarpFactor = 1
				--		this.SubType = 4
						this.Tooltip = {"tooltip_Init_TimeWarpC",StartingMinute,"A",StartingMinute+5,"B",Now,"C",timeTot,"D","Small","E",myTimeWarpFactor,"F" }
					end
					timeTot = 0
					timePerUpdate = 1 / myTimeWarpFactor
				--	print(timePerUpdate)
				end
			end
		else
			timeTot = timeTot+timePassed
			if timeTot > timePerUpdate then
			--	this.SubType = 0
				Set("TimeWarp",myTimeWarpFactor)
				Set("Tooltip","")
				timePerUpdate = nil
			end
		end
	else
		timeInit = timeInit+timePassed
		Now = math.floor(math.mod(World.TimeIndex,60))
	--	print("Now: "..Now)
		if Now > 50 then
			timeInit = 0
			Set("Tooltip","tooltip_Init_TimeWarpA")
		else
			StartingMinute = Now
		end
	end
end




















-------------------------------------------------------------------------------------------
-- Helper Functions
------------------------------------------------------------------------------------------- 
function Set(name, value)
    Object.SetProperty(name, value);
end
function Get(name)
    return Object.GetProperty(name);
end
function GetN(name)
    return tonumber(Object.GetProperty(name));
end
function GetFrom(ident, name)
    return Object.GetProperty(ident, name);
end
function SetOn(ident, name, value)
    return Object.SetProperty(ident, name, value);
end
function Print(text)
    Game.DebugOut("Cat", text);
end
function PrintProperty(name)
    local property = Get(name);
    if property == nil then
        property = "nil";
    end    
    
    Print(name .. ": " .. tostring(property));
end
function PropStr(prop)
    return " " .. prop .. ": " .. tostring(Get(prop));
end--]]


-- get the length of a table
function len(tab)
	local count = 0
	for _ in pairs(tab) do
		count = count + 1
	end
	return count
end
--Return Object if in range.
function GetObject(type,id,dist)
	objs = Object.GetNearbyObjects(type,dist or 1)
	for o,d in pairs(objs) do
		 if o.Id.i == id then
		 	return o
		 end
	end
end
--Find Object after Load.
function Load(Object, Type, ID, dist)
    if Object == "" then
        Print(tostring("Trying to load "..Type.." with ID: "..ID));
        TempID = Get(tostring(ID));
        Object = GetObject(Type,TempID,dist);
        Print("Found: "..Type.." Table: "..tostring(Object).." ID: "..TempID);
    end
	if Object == nil then Set(ID,"None") end
    return Object
end
